/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: RobertsVIIGenerator.java,v 0420807a3b72 2010/08/12 20:17:42 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.taxonomy.birds.roberts;

import it.tidalwave.bluebill.taxonomy.birds.BirdTaxonomyImporter;
import it.tidalwave.bluebill.taxonomy.birds.DefaultTranslator;
import it.tidalwave.bluebill.taxonomy.birds.GeneratorSupport;
import java.io.File;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class RobertsVIIGenerator extends GeneratorSupport
  {
    public static final String TAXONOMY_NAME = "Roberts VII";
    public static final String TAXONOMY_FILE_NAME = "RobertsVII";

    public static void main (final @Nonnull String ... args)
      throws Exception
      {
        new RobertsVIIGenerator(args[0]).execute();
      }

    public RobertsVIIGenerator (final @Nonnull String baseDir)
      {
        super(baseDir, TAXONOMY_NAME, TAXONOMY_FILE_NAME);
      }

    @Nonnull
    public BirdTaxonomyImporter run()
      throws Exception
      {
        final RobertsVIIImporter importer = new RobertsVIIImporter();
        importer.setCatalogueOfLifeTranslator(new DefaultTranslator(RobertsVIIImporter.class, "RobertsVIIToCatalogueOfLifeTranslations.config"));
        importer.setIdentifierMapFile(new File(resourcesFolder, "artifacts/TaxonIdMap.txt.gz"));
        importer.run(repository, taxonomyName);

        return importer;
      }
  }
